import {Commands, Dimension, Player, World} from "mojang-minecraft"

const version = "0.7.5";
const cmdPrefix = "+";
const adminTag = "Admin";
const bf = "@e[type=npc,name=better_faction,tag=better_faction]"
let delay;

World.events.tick.subscribe(data => {
    let x;
    let y;
    let z;
    const pl = World.getPlayers();

    for (let i = 0; i < pl.length; i++) {
        const tpa = getScoreboardValue(`"${pl[i].name}" tpa`);
        const faction = getScoreboardValue(`"${pl[i].name}" d:faction`);
        if (tpa != 0)
        {
            if (tpa == 1)
            {
                const tags = findTagsStartWith(pl[i].name, "tpa:");
                for (const tag of tags) {
                    runCommand(`tag "${pl[i].name}" remove ${tag}`);
                }
                tellraw(pl[i].name, "§8[tpa] §ctpa request cancelled.");
            }
            runCommand(`scoreboard players remove "${pl[i].name}" tpa 1`);
        }
        if (faction != 0)
        {
            if (faction == 1)
            {
                const tags = findTagsStartWith(pl[i].name, "invit:");
                for (const tag of tags) {
                    runCommand(`tag "${pl[i].name}" remove ${tag}`);
                }
                tellraw(pl[i].name, "§8[faction] §cfaction invite cancelled.");
            }
            runCommand(`scoreboard players remove "${pl[i].name}" d:faction 1`);
        }
        if (hasTag(pl[i].name,"co")) {
            x = Math.ceil(pl[i].location.x+0.0001)-1;
            y = Math.round(pl[i].location.y-0.4999);
            z = Math.ceil(pl[i].location.z+0.0001)-1;
            actionbarRaw(pl[i].name, `§b§lX§r: §e${x}§r, §b§lY§r: §e${y}§r, §b§lZ§r: §e${z}\n§r§lChunk :\n§rX: §e${Math.ceil((x+1)/16)}§r, Z: §e${Math.ceil((z+1)/16)}`);
        }
    }
    delay = getScoreboardValue("initDelay map");
    if (delay != 0)
    {
        if(delay == 1)
        {
            runCommand("fill 0 0 0 3 3 3 bedrock");
            runCommand("fill 1 1 1 1 2 1 structure_void");
            if (entityExist("better_faction","minecraft:npc") == false)
            { 
                runCommand("summon npc 1 1 1 a better_faction");
            }
            runCommand("tag @e[name=better_faction,x=1,z=1,y=1,r=1] add better_faction");
            initEnd();
        }
        runCommand("scoreboard players remove initDelay map 1");
    }
    
})

World.events.beforeChat.subscribe(data =>{
    if (data.message.substr(0, cmdPrefix.length) == cmdPrefix)
    {
        data.cancel = true;
        allCommand(data);
    }
})

export function allCommand(data) {
    if (data.message.trim() == cmdPrefix + "help")
    {
        if (entityExist("better_faction","minecraft:npc") == false)
        { help(data); }
        else if (testAccess(data, "help"))
        { help(data); }
    }
    if (data.message.trim() == cmdPrefix + "co" && testAccess(data,"co"))
    {
        if (hasTag(data.sender.name,"co"))
        {
            tellraw(data.sender.name,"§eCoordianate §cOFF.");
            runCommand(`tag "${data.sender.name}" remove co`);
        }
        else
        {
            tellraw(data.sender.name,"§eCoordianate §aON.");
            runCommand(`tag "${data.sender.name}" add co`);
        }
    }
    if (data.message.trim() == cmdPrefix + "log" && hasTag(data.sender.name, adminTag) && testAccess(data,"log"))
    {
        if (hasTag(data.sender.name,"log"))
        {
            tellraw(data.sender.name,"§eLog §cOFF.");
            runCommand(`tag "${data.sender.name}" remove log`);
        }
        else
        {
            tellraw(data.sender.name,"§eLog §aON.");
            runCommand(`tag "${data.sender.name}" add log`);
        }
    }
    if (data.message.trim() == cmdPrefix + "spawn" && testAccess(data,"spawn"))
    { tpSpawn(data); }

    if (data.message.trim() == cmdPrefix + "setspawn" && testAccess(data,"setspawn"))
    {
        const isAdmin = hasTag(data.sender.name, adminTag);

        if (isAdmin == true) { setSpawn(data); }
        else { log(`utilisation frauduleuse par ${data.sender.name} de la commande +setspawn`); }
    }
    
    if (data.message.startsWith(cmdPrefix + "sethome ") && testAccess(data,"sethome"))
    {
        runCommand(`scoreboard players add "${data.sender.name}" homeCount 0`)
        if (parseInt(getScoreboardValue(`"${data.sender.name}" homeCount`)) < parseInt(getScoreboardValue("limitHome map")) && data.message.length > data.message.split(' ')[0].length+1)
        {
            if (getCurrentDimension(data.sender.name) == 0 ) 
            { sethome(getScoreboardValue(`"${data.sender.name}" homeCount`), data); }
            else
            { tellraw(data.sender.name, "§cyou can't set home in other dimension than overworld.")}
        }
        else
        { tellraw(data.sender.name, "§cinvalid command or home limit reach."); }
    }
    if (data.message.startsWith(cmdPrefix + "delhome ") && testAccess(data,"delhome"))
    { delhome(data); }
    if (data.message.startsWith(cmdPrefix + "home ") && testAccess(data,"home"))
    { home(data); }
    if (data.message == cmdPrefix + "listhome" || data.message == cmdPrefix + "list home" && testAccess(data,"listhome")) 
    { listhome(data); }

    if (data.message.startsWith(cmdPrefix + "tpa ") && testAccess(data,"tpa"))
    { tpa(data); }
    if (data.message == cmdPrefix + "tpaccept" && testAccess(data,"tpaccept"))
    { tpaccept(data); }

    if (data.message.trim().startsWith(cmdPrefix + "faction "))
    {
        const facName = findFactionName(data.sender.name);
        let parsed = data.message.trim().substr(data.message.split(" ")[0].length + 1);
        if (parsed.startsWith("create ") && testAccess(data,"facCreate"))
        {
            runCommand(`scoreboard players add \"${data.sender.name}\" better_faction 0`); //init scoreboard
            if (getScoreboardValue(`\"${data.sender.name}\" better_faction`) == 0)
            {
                parsed = parsed.substr(parsed.split(' ')[0].length + 1);
                if (parsed.match(/^([0-9a-zA-Z_]){3,12}$/))
                {
                    if (scoreExist("bf:"+parsed) == false)
                    { createFaction(findPlayer(data.sender.name),parsed); }
                    else
                    { tellraw(data.sender.name,"§cThis name is already used."); }
                }
                else
                { tellraw(data.sender.name, "§cInvalid Name (no special characters/space , length between 3 and 12)"); }
            }
            else
            { tellraw(data.sender.name, "§cYou are already in a faction."); }
        }
        else if (parsed.startsWith("invite ") && parseInt(getScoreboardValue(`\"${data.sender.name}_Auth\" \"${facName}\"`)) <= -3 && testAccess(data,"facInvite"))
        {
            parsed = parsed.substr(parsed.split(" ")[0].length + 1).trim().replace(/"|@/g,"");
            if (entityExist(parsed,"minecraft:player"))
            {
                runCommand(`scoreboard players add \"${parsed}\" better_faction 0`);
                if (getScoreboardValue(`\"${parsed}\" better_faction`) == 0)
                {
                    try
                    {
                        const tags = findTagsStartWith(playertp.name, "invit:");
                        for (const tag of tags) {
                           runCommand(`tag "${playertp.name}" remove ${tag}`);
                        }
                    }
                    catch(er)
                    {}
                    runCommand(`tag \"${parsed}\" add invite:${getScoreboardValue(`\"${data.sender.name}\" better_faction`)}:${facName.split(":")[1]}`);
                    runCommand(`scoreboard players set \"${parsed}\" d:faction 2400`);
                    tellraw(data.sender.name, "§6" + parsed + " §einvited.");
                    tellraw(parsed, "§eyou recieve an invite to join the §a"+facName.split(":")[1]+" §efaction. §7+faction accept")
                }
            }
        }
        else if (parsed == ("accept") && testAccess(data,"facAccept"))
        {
            const tags = findTagsStartWith(data.sender.name, "invite:");
                runCommand(`scoreboard players set \"${data.sender.name}\" better_faction ${tags[0].split(":")[1]}`);
                runCommand(`scoreboard players set \"${data.sender.name}_Auth\" \"bf:${tags[0].split(":")[2]}\" -1`);
                runCommand(`tag \"${data.sender.name}\" remove ${tags[0]}`);
                runCommand(`scoreboard players set \"${data.sender.name}\" d:faction 0`);
                runCommand(`scoreboard players add memberCount bf:${tags[0].split(":")[2]} 1`)
                tellraw(`@a[scores={bf:${tags[0].split(":")[2]}=-4..-1}]`,"§a" + data.sender.name + " §ejoin the faction !");
                log("§6"+data.sender.name+" §ejoin the §a" + tags[0].split(":")[2]+"§e faction.");
        }
        else if (parsed.startsWith("rank ") && parseInt(getScoreboardValue(`\"${data.sender.name}_Auth\" \"${facName}\"`)) <= -3 && testAccess(data,"facRank"))
        {
            parsed = parsed.substr(parsed.split(" ")[0].length + 1).replace(/"|@/g,"");
            const memberAuth = getScoreboardValue(`\"${parsed}_Auth\" \"${facName}\"`);
            const leaderAuth = getScoreboardValue(`\"${data.sender.name}_Auth\" \"${facName}\"`);
            if (parseInt(memberAuth) > parseInt(leaderAuth) && memberAuth != 0 && leaderAuth != 0 && parseInt(leaderAuth) <= -3)
            {
                if (memberAuth == -3)
                { 
                    runCommand(`scoreboard players set \"${parsed}_Auth\" \"${facName}\" -4`);
                    runCommand(`scoreboard players set \"${data.sender.name}_Auth\" \"${facName}\" -3`)
                    tellraw(parsed, "§eyour the new leader!");
                    tellraw(data.sender.name, "§eyou have been unrank and §6"+parsed+" §eis the new leader.")
                }
                else
                { 
                    runCommand(`scoreboard players remove \"${parsed}_Auth\" \"${facName}\" 1`);
                    tellraw(parsed, "§eyou have been ranked up !");
                    tellraw(data.sender.name, "§a"+parsed+"§e has been ranked up.");
                    log("§a" + parsed + " §eranked by §a" + data.sender.name+".");
                }
            }
            else
            {
                tellraw(data.sender.name, "§cError, you can't do that.");
            }
        }
        else if (parsed.startsWith("unrank ") && parseInt(getScoreboardValue(`\"${data.sender.name}_Auth\" \"${facName}\"`)) <= -3 && testAccess(data,"facUnrank"))
        {
            parsed = parsed.substr(parsed.split(" ")[0].length + 1).replace(/"|@/g,"");
            const memberAuth = getScoreboardValue(`\"${parsed}_Auth\" \"${facName}\"`);
            const leaderAuth = getScoreboardValue(`\"${data.sender.name}_Auth\" \"${facName}\"`);
            if (parseInt(memberAuth) > parseInt(leaderAuth) && memberAuth != 0 && leaderAuth != 0 && parseInt(leaderAuth) <= -3)
            {
                if (memberAuth == -1)
                { 
                    runCommand(`scoreboard players reset \"${parsed}_Auth\" \"${facName}\"`);
                    runCommand(`scoreboard players set \"${parsed}\" better_faction 0`);
                    if (getScoreboardValue(`memberCount \"${facName}\"`) == 1) //preparation pour la gestion admin.
                    {
                        runCommand(`tag ${bf} remove faction:${getScoreboardValue(`\"${data.sender.name}\" better_faction`)}:${facName.split(":")[1]}`);
                        runCommand(`scoreboard objectives remove \"${facName}\"`);
                        log(`§a${facName.split(":")[1]} §eHas been deleted.`);
                    }
                    else
                    {
                        runCommand(`scoreboard players remove memberCount \"${facName}\" 1`);
                    }
                    tellraw(parsed, "§eyou have been kicked from the §a"+facName.split(":")[1]+" §e Faction.");
                    tellraw(data.sender.name, "§eyou have kicked §6"+parsed+" §e.");
                }
                else
                { 
                    runCommand(`scoreboard players add \"${parsed}_Auth\" \"${facName}\" 1`);
                    tellraw(parsed, "§eyou have been unranked !");
                    tellraw(data.sender.name, parsed+" has been unranked.");
                    log("§a" + parsed + " §eunranked by §a" + data.sender.name+".");
                }
            }
            else
            {
                tellraw(data.sender.name, "§cError, you can't do that.");
            }
        }
        else if (parsed.startsWith("quit") && getScoreboardValue(`\"${data.sender.name}\" better_faction`) != 0 && testAccess(data,"facQuit"))
        {
            if (getScoreboardValue(`\"${data.sender.name}\" \"${data.sender.name}_Auth\"`) == -4)
            {
                runCommand(`scoreboard players set leader \"${facName}\" 0`);
            }
            if (getScoreboardValue(`memberCount \"${facName}\"`) == 1)
            {
                runCommand(`tag ${bf} remove faction:${getScoreboardValue(`\"${data.sender.name}\" better_faction`)}:${facName.split(":")[1]}`);
                runCommand(`scoreboard objectives remove \"${facName}\"`);
                log(`§a${facName.split(":")[1]} §eHas been deleted.`);
            }
            runCommand(`scoreboard players remove memberCount \"${facName}\" 1`);
            runCommand(`scoreboard players reset \"${data.sender.name}_Auth\" ${facName}`);
            runCommand(`scoreboard players set \"${data.sender.name}\" better_faction 0`);
            tellraw(data.sender.name,"§eyou leave the §6"+facName.split(":")[1]+" §efaction.");
        }
        else
        { tellraw(data.sender.name, "§cError, you can't do that."); }
    }

    if (data.message.trim().startsWith(cmdPrefix + "access ") && hasTag(data.sender.name,"Admin") && testAccess(data,"access"))
    {
        let parsed = data.message.trim().substr(data.message.split(" ")[0].length + 1);
        if (parsed.startsWith("allow "))
        {
            parsed = parsed.substr(parsed.split(" ")[0].length+1);
            if (parsed.startsWith("help "))
            { access(data.sender.name,"allow","help",parsed.substr(parsed.split(" ")[0].length + 1).trim()); }
            if (parsed.startsWith("init all "))
            { access(data.sender.name,"allow","initall",parsed.substr(parsed.split(" ")[0].length + parsed.split(" ")[1].length + 2).trim()); }
            if (parsed.startsWith("init "))
            { access(data.sender.name,"allow","init",parsed.substr(parsed.split(" ")[0].length + 1).trim()); }
            if (parsed.startsWith("co "))
            { access(data.sender.name,"allow","co",parsed.substr(parsed.split(" ")[0].length + 1).trim()); }
            if (parsed.startsWith("log "))
            { access(data.sender.name,"allow","log",parsed.substr(parsed.split(" ")[0].length + 1).trim()); }
            if (parsed.startsWith("setspawn "))
            { access(data.sender.name,"allow","setsapwn",parsed.substr(parsed.split(" ")[0].length + 1).trim()); }
            if (parsed.startsWith("spawn "))
            { access(data.sender.name,"allow","spawn",parsed.substr(parsed.split(" ")[0].length + 1).trim()); }
            if (parsed.startsWith("sethome "))
            { access(data.sender.name,"allow","sethome",parsed.substr(parsed.split(" ")[0].length + 1).trim()); }
            if (parsed.startsWith("delhome "))
            { access(data.sender.name,"allow","delhome",parsed.substr(parsed.split(" ")[0].length + 1).trim()); }
            if (parsed.startsWith("listhome "))
            { access(data.sender.name,"allow","listhome",parsed.substr(parsed.split(" ")[0].length + 1).trim()); }
            if (parsed.startsWith("home "))
            { access(data.sender.name,"allow","home",parsed.substr(parsed.split(" ")[0].length + 1).trim()); }
            if (parsed.startsWith("tpa "))
            { access(data.sender.name,"allow","tpa",parsed.substr(parsed.split(" ")[0].length + 1).trim()); }
            if (parsed.startsWith("tpaccept "))
            { access(data.sender.name,"allow","tpaccept",parsed.substr(parsed.split(" ")[0].length + 1).trim()); }
            if (parsed.startsWith("faction create "))
            { access(data.sender.name,"allow","facCreate",parsed.substr(parsed.split(" ")[0].length + parsed.split(" ")[1].length + 2).trim()); }
            if (parsed.startsWith("faction quit "))
            { access(data.sender.name,"allow","facQuit",parsed.substr(parsed.split(" ")[0].length + parsed.split(" ")[1].length + 2).trim()); }
            if (parsed.startsWith("faction invite "))
            { access(data.sender.name,"allow","facInvite",parsed.substr(parsed.split(" ")[0].length + parsed.split(" ")[1].length + 2).trim()); }
            if (parsed.startsWith("faction accept "))
            { access(data.sender.name,"allow","facAccept",parsed.substr(parsed.split(" ")[0].length + parsed.split(" ")[1].length + 2).trim()); }
            if (parsed.startsWith("faction rank "))
            { access(data.sender.name,"allow","facRank",parsed.substr(parsed.split(" ")[0].length + parsed.split(" ")[1].length + 2).trim()); }
            if (parsed.startsWith("faction unrank "))
            { access(data.sender.name,"allow","facUnrank",parsed.substr(parsed.split(" ")[0].length + parsed.split(" ")[1].length + 2).trim()); }
            if (parsed.startsWith("access "))
            { access(data.sender.name,"allow","access",parsed.substr(parsed.split(" ")[0].length + 1).trim()); }
            /*if (parsed.startsWith("remove "))
            {
                removeAccess(data.sender.name, "allow", parsed.substr(parsed.split(" ")[0] + 1).split(" ")[0],parsed.substr(parsed.split(" ")[0] + 1).split(" ")[1])
            }*/
            if (parsed.startsWith("list"))
            {
                listAccess(data,"allow");
            }
        }
        else if (parsed.startsWith("deny "))
        {
            parsed = parsed.trim().substr(parsed.split(" ")[0].length + 1);
            if (parsed.startsWith("help "))
            { access(data.sender.name, "deny", "help" ,parsed.substr(parsed.split(" ")[0].length + 1).trim()); }
            if (parsed.startsWith("init all "))
            { access(data.sender.name, "deny", "initall" ,parsed.substr(parsed.split(" ")[0].length + parsed.split(" ")[1].length + 2).trim()); }
            if (parsed.startsWith("init "))
            { access(data.sender.name, "deny", "init" ,parsed.substr(parsed.split(" ")[0].length + 1).trim()); }
            if (parsed.startsWith("co "))
            { access(data.sender.name ,"deny" ,"co" ,parsed.substr(parsed.split(" ")[0].length + 1).trim()); }
            if (parsed.startsWith("log "))
            { access(data.sender.name ,"deny" ,"log" ,parsed.substr(parsed.split(" ")[0].length + 1).trim()); }
            if (parsed.startsWith("setspawn "))
            { access(data.sender.name ,"deny" ,"setsapwn" ,parsed.substr(parsed.split(" ")[0].length + 1).trim()); }
            if (parsed.startsWith("spawn "))
            { access(data.sender.name ,"deny" ,"spawn" ,parsed.substr(parsed.split(" ")[0].length + 1).trim()); }
            if (parsed.startsWith("sethome "))
            { access(data.sender.name ,"deny" ,"sethome" ,parsed.substr(parsed.split(" ")[0].length + 1).trim()); }
            if (parsed.startsWith("delhome "))
            { access(data.sender.name ,"deny" ,"delhome" ,parsed.substr(parsed.split(" ")[0].length + 1).trim()); }
            if (parsed.startsWith("listhome "))
            { access(data.sender.name ,"deny" ,"listhome" ,parsed.substr(parsed.split(" ")[0].length + 1).trim()); }
            if (parsed.startsWith("home "))
            { access(data.sender.name ,"deny" ,"home" ,parsed.substr(parsed.split(" ")[0].length + 1).trim()); }
            if (parsed.startsWith("tpa "))
            { access(data.sender.name ,"deny" ,"tpa" ,parsed.substr(parsed.split(" ")[0].length + 1).trim()); }
            if (parsed.startsWith("tpaccept "))
            { access(data.sender.name ,"deny" ,"tpaccept" ,parsed.substr(parsed.split(" ")[0].length + 1).trim()); }
            if (parsed.startsWith("faction create "))
            { access(data.sender.name ,"deny" ,"facCreate" ,parsed.substr(parsed.split(" ")[0].length + parsed.split(" ")[1].length + 2).trim()); }
            if (parsed.startsWith("faction quit "))
            { access(data.sender.name ,"deny" ,"facQuit" ,parsed.substr(parsed.split(" ")[0].length + parsed.split(" ")[1].length + 2).trim()); }
            if (parsed.startsWith("faction invite "))
            { access(data.sender.name ,"deny" ,"facInvite" ,parsed.substr(parsed.split(" ")[0].length + parsed.split(" ")[1].length + 2).trim()); }
            if (parsed.startsWith("faction accept "))
            { access(data.sender.name ,"deny" ,"facAccept" ,parsed.substr(parsed.split(" ")[0].length + parsed.split(" ")[1].length + 2).trim()); }
            if (parsed.startsWith("faction rank "))
            { access(data.sender.name ,"deny" ,"facRank" ,parsed.substr(parsed.split(" ")[0].length + parsed.split(" ")[1].length + 2).trim()); }
            if (parsed.startsWith("faction unrank "))
            { access(data.sender.name ,"deny" ,"facUnrank" ,parsed.substr(parsed.split(" ")[0].length + parsed.split(" ")[1].length + 2).trim()); }
            if (parsed.startsWith("access "))
            { access(data.sender.name ,"deny" ,"access" ,parsed.substr(parsed.split(" ")[0].length + 1).trim()); }
            /*if (parsed.startsWith("remove "))
            {
                removeAccess(data.sender.name, "deny", parsed.substr(parsed.split(" ")[0] + 1).split(" ")[0],parsed.substr(parsed.split(" ")[0] + 1).split(" ")[1])
            }*/
            if (parsed.startsWith("list"))
            {
                listAccess(data,"deny");
            }
        }
    }

    if (data.message.trim() == cmdPrefix + "init") {
        const isAdmin = hasTag(data.sender.name, adminTag);
        if (entityExist("better_faction","minecraft:npc") == false)
        { if (isAdmin) { init(); } }
        else if (testAccess(data,"init"))
        { if (isAdmin) { init(); } }
    }
    if (data.message.trim() == (cmdPrefix + "init all")) {
        const isAdmin = hasTag(data.sender.name, adminTag);
        if (entityExist("better_faction","minecraft:npc") == false)
        { if (isAdmin) { initALL(); } }
        else if (testAccess(data,"initall"))
        { if (isAdmin) { initALL(); } }
    }
}

export function testAccess(data, command)
{
    const allows = findTagsStartWith2("better_faction", "better_faction", "access:allow:" + command);
    const denys = findTagsStartWith2("better_faction", "better_faction", "access:deny:" + command);
    if (denys.length != 0)
    {
        for (const deny of denys)
        {
            if (hasTag(data.sender.name, deny.split(":")[3]))
            { tellraw(data.sender.name, "§eAccess deny"); return false; }
        }
    }
    if (allows.length != 0)
    { for (const allow of allows)
        {
            if (hasTag(data.sender.name, allow.split(":")[3]))
            { return true; }
        }
    }
    else
    { return true; }
    tellraw(data.sender.name, "§enot allowed to use this command");
    return false;
}
export function listAccess(data,type)
{
    if (type == "allow")
    {
        const allows = findTagsStartWith2("better_faction", "better_faction", "access:allow:");
        for (const allow of allows)
        {
            tellraw(data.sender.name, "§e§lAllow §r§e- Command : §a" + allow.split(":")[2] + "§e | Tag : §a"+allow.split(":")[3]);
        }
    }
    if (type == "deny")
    {
        const denys = findTagsStartWith2("better_faction", "better_faction", "access:deny:");
        for (const deny of denys)
        {
            tellraw(data.sender.name, "§e§ldeny  §r§e- Command : §a" + deny.split(":")[2] + "§e | Tag : §a"+deny.split(":")[3]);
        }
    }
}

export function access(name, type, command, tag) {
    if (tag.match(/^([a-zA-Z_]){1,8}$/))
    {
        runCommand(`tag ${bf} add access:${type}:${command}:${tag}`);
        tellraw(name, `§7[access] §eadd access, type : ${type}, command : ${command}, tag : ${tag}`);
        log(`§eaccess, type : §d${type}§e, command : §d${command}§e, tag : §d${tag}§e by §6${name}`);
    }
    else
    {
        tellraw(name, "§cWron syntax (no number or space, btw 1 and 8 letters)");
    }
}
export function removeAccess(name, type, command, tag)
{
    if (type == "allow")
    {
        const allows = findTagsStartWith2("better_faction", "better_faction", "access:allow:");
        for (const allow of allows)
        {
            if (command == allow.split(":")[2] && tag == allow.split(":")[3])
            {
                runCommand(`tag ${bf} remove ${allow}`);
                tellraw(data.sender.name, "§cAccess Deleted.");
                break;
            }
        }
    }
    if (type == "deny")
    {
        const denys = findTagsStartWith2("better_faction", "better_faction", "access:deny:");
        for (const deny of denys)
        {
            if (command == deny.split(":")[2] && tag == deny.split(":")[3])
            {
                runCommand(`tag ${bf} remove ${deny}`);
                tellraw(data.sender.name, "§cAccess Deleted.");
                break;
            }
        }
    }
}

export function createFaction(player, facName) {
    runCommand("scoreboard players add id better_faction 1");
    runCommand(`scoreboard players operation \"${player.name}\" better_faction = id better_faction`);
    runCommand("scoreboard objectives add \"bf:" + facName + "\" dummy \"§a" + facName + "§r\"");
    runCommand("tag " + bf + " add faction:" + getScoreboardValue("id better_faction") + ":" + facName);
    runCommand(`scoreboard players set \"${player.name}_Auth\" bf:${facName} -4`);
    runCommand("scoreboard players set money bf:" + facName + " 0");
    runCommand("scoreboard players set memberCount bf:" + facName + " 1");

    tellraw(player.name,"§ayou just create the §6" + facName + "§a faction.");
    log(`§6${player.name} §ecreate §a${facName} §efaction.`);
}

export function tpa(data) {
    const player = findPlayer(data.sender.name);
    let message = data.message.trim().substr(data.message.split(" ")[0].length + 1);
    const playertp = findPlayer(message.replace(/"|@/g,""));
    if(playertp != undefined)
    {
        runCommand(`scoreboard players set "${player.name}" tpa 600`);
        runCommand(`scoreboard players set "${playertp.name}" tpa 600`);
        const tags = findTagsStartWith(playertp.name, "tpa:");
        for (const tag of tags) {
            runCommand(`tag "${playertp.name}" remove ${tag}`);
        }
        runCommand(`tag "${playertp.name}" add tpa:${player.name.replace(/ /g,".")}:${playertp.name.replace(/ /g,".")}`);
        tellraw(player.name, "§8[tpa] §erequest sended to " + playertp.name + ".");
        tellraw(playertp.name, "§8[tpa] §e" + player.name + " want to tp to you §7type "+cmdPrefix+"tpaccept");
    }
}
export function tpaccept(data) { //si delai tpa est pas a 0
    const player = findPlayer(data.sender.name);
    const tag = findTagsStartWith(player.name, "tpa:")[0].replace(/\./g, " ");
    if (getScoreboardValue(`"${player.name}" tpa`) != 0)
    { runCommand(`tp "${tag.split(':')[1]}" "${tag.split(':')[2].trim()}"`); }
    const tags = findTagsStartWith(player.name, "tpa:");
    for (const tag of tags) {
        runCommand(`tag "${player.name}" remove ${tag}`);
    }
    runCommand(`scoreboard players set "${tag.split(':')[2]}" tpa 0`);
    runCommand(`scoreboard players set "${tag.split(':')[1]}" tpa 0`);
}

export function delhome(data)
{
    const player = findPlayer(data.sender.name);
    let message = data.message.substr(data.message.split(' ')[0].length+1);

    for (let i = 0; i < getScoreboardValue(`limitHome map`); i++) {
        if(hasTag(player.name, `home:${i}:${message}`) == true) 
        {
            runCommand(`scoreboard players remove "${player.name}" homeCount 1`);
            runCommand(`tag "${player.name}" remove home:${i}:${message}`);
            tellraw(player.name, "§ehome §l§3" + message + "§r§e deleted.");
            break;
        }
    }
}

export function home(data) {
    const player = findPlayer(data.sender.name);
    let message = data.message.substr(data.message.split(' ')[0].length+1);
    let x,y,z;

    for (let i = 0; i < getScoreboardValue(`limitHome map`); i++) {
        if(hasTag(player.name, `home:${i}:${message}`)) 
        {
            x = getScoreboardValue(`"${player.name}" homeX${i}`);
            y = getScoreboardValue(`"${player.name}" homeY${i}`);
            z = getScoreboardValue(`"${player.name}" homeZ${i}`);
            break;
        }
    }
    runCommand(`tp "${player.name}" ${x} ${y} ${z}`);
}

export function sethome(id, data) {
    const player = findPlayer(data.sender.name);
    const message = data.message.substr(data.message.split(' ')[0].length+1).trim();
    const limitHome = getScoreboardValue("limitHome map");
    const x = Math.ceil(player.location.x+0.0001)-1;
    const y = Math.ceil(player.location.y-0.4999);
    const z = Math.ceil(player.location.z+0.0001)-1;
    let exist = false;

    for (let i = 0; i < limitHome; i++) {
        if(hasTag(player.name, `home:${i}:${message}`) == true) 
        {
            tellraw(player.name, " §cce this name is already used");
            exist = true;
            break;
        }
    }
    if (!message.match(/^([0-9a-zA-Z_]){1,20}$/))
    {
       tellraw(player.name, " §cinvalid Name")
        exist = true;
    }
    for (let i = 0; i < limitHome; i++) {
        if(findTagsStartWith(player.name, "home:" + i + ":").length == 0)
        { 
            id = i;
            break;
        }
    }
    if (exist == false)
    {
        runCommand(`scoreboard players set "${player.name}" homeX${id} ${x}`);
        runCommand(`scoreboard players set "${player.name}" homeY${id} ${y}`);
        runCommand(`scoreboard players set "${player.name}" homeZ${id} ${z}`);
        
        runCommand(`tag "${player.name}" add home:${id}:${message}`);
        runCommand(`scoreboard players add "${player.name}" homeCount 1`);

        tellraw(player.name, `§ehome n°${id} added with the name ${message} in ${x} ${y} ${z}`);
        log(`§ehome n°${id} '${message}' for §6${player.name}§e in ${x} ${y} ${z}`);
    }
}

export function listhome(data)
{
    const player = findPlayer(data.sender.name);

    tellraw(player.name, "§aHome List :");
    const listH = findTagsStartWith(player.name, "home");
    if (listH.length != 0) 
    {
        for (let i = 0; i < listH.length; i++) {
            const homeName = listH[i].split(':')[2];
            const x = getScoreboardValue(`"${player.name}" homeX`+listH[i].split(':')[1]);
            const y = getScoreboardValue(`"${player.name}" homeY`+listH[i].split(':')[1]);
            const z = getScoreboardValue(`"${player.name}" homeZ`+listH[i].split(':')[1]);
            tellraw(player.name, `§e- §o${homeName}§r§a ${x} ${y} ${z}`);
        }
    }
    else { tellraw(player.name, "§cNo home.")}
}

/*export function initHome(data) {
    let message = parseInt(data.message.substr(9, data.message.length - 9));
}*/

export function tpSpawn(data)
{
    let x = getScoreboardValue("spawnX map");
    let y = getScoreboardValue("spawnY map");
    let z = getScoreboardValue("spawnZ map");

    runCommand(`tp "${data.sender.name}" ${x} ${y} ${z}`);
}

export function setSpawn(data) {
    const player = findPlayer(data.sender.name);
    const x = Math.ceil(player.location.x+0.0001)-1;
    const y = Math.ceil(player.location.y-0.4999);
    const z = Math.ceil(player.location.z+0.0001)-1;
    runCommand(`scoreboard players set spawnX map ${x}`);
    runCommand(`scoreboard players set spawnY map ${y}`);
    runCommand(`scoreboard players set spawnZ map ${z}`);

    tellraw(data.sender.name, `§e+spawn set §a${x} ${y} ${z}`);
}

export function init()
{
    runCommand(`say §aInitialisation started...`);
    runCommand(`scoreboard objectives add homeCount dummy homeCount`)

    runCommand("scoreboard objectives add map dummy map");
    runCommand("scoreboard objectives add tpa dummy tpa");
    runCommand("scoreboard objectives add d:faction dummy \"§ddelay faction§r\"");
    runCommand(`say §aMap set...`);

    for (let i = 0; i < getScoreboardValue(`limitHome map`); i++) {
        runCommand(`scoreboard objectives add homeX${i} dummy home`);
        runCommand(`scoreboard objectives add homeY${i} dummy home`);
        runCommand(`scoreboard objectives add homeZ${i} dummy home`);
   }

   runCommand("tickingarea add 3 0 3 0 3 0");
   runCommand("scoreboard players set initDelay map 20");
}
export function initALL()
{
    runCommand(`say §aInitialisation started...`);
    try
    {
        for (let i = 0; i < getScoreboardValue(`limitHome map`); i++) {
            runCommand(`scoreboard objective remove homeX${i}`);
            runCommand(`scoreboard objective remove homeY${i}`);
            runCommand(`scoreboard objective remove homeZ${i}`);
        }
    }
    catch (err) {}
    runCommand(`scoreboard objectives remove homeCount`);
    runCommand(`scoreboard objectives add homeCount dummy homeCount`);

    runCommand(`say §aHome Cleared...`);
    runCommand("scoreboard objectives remove map");
    runCommand("scoreboard objectives remove tpa");
    runCommand("scoreboard objectives add tpa dummy tpa");
    runCommand(`say §aMap Cleared`);

    runCommand("scoreboard objectives add map dummy map");
    runCommand("scoreboard players set limitHome map 3");
    runCommand("scoreboard players set limitFacMember map 5");
    runCommand("scoreboard objectives remove d:faction");
    runCommand("scoreboard objectives add d:faction dummy \"§ddelay faction§r\"");
    runCommand(`say §aMap Reset...`);

    runCommand("scoreboard objectives remove better_faction");
    runCommand("scoreboard objectives add better_faction dummy \"§efaction id§r\"");
    runCommand(`say §aFaction Reset...`);

    runCommand("scoreboard players set spawnX map 0");
    runCommand("scoreboard players set spawnY map 4");
    runCommand("scoreboard players set spawnZ map 0");
    runCommand(`say §aSpawn Reset`);

    for (let i = 0; i < getScoreboardValue(`limitHome map`); i++) {
        runCommand(`scoreboard objectives add homeX${i} dummy home`);
        runCommand(`scoreboard objectives add homeY${i} dummy home`);
        runCommand(`scoreboard objectives add homeZ${i} dummy home`);
    }

   runCommand("tickingarea add 3 0 3 0 3 0");
   runCommand("scoreboard players set initDelay map 20");
}
export function initEnd() {
    log("§aWorld initiated correctly (§cnever kill the npc named better_faction !§a)");
}

///Faction Function///

export function findFactionName(playerName)
{
    const id = getScoreboardValue(`\"${playerName}\" better_faction`);
    let facName = undefined;
    try
    {    
        facName = findTagsStartWith2("better_faction", "better_faction",`faction:${id}:`);
        return "bf:" + facName[0].split(":")[2];
    }
    catch(err)
    {
        return undefined;
    }
}

///Function///

export function getScoreboardValue(score)
{
    var value = runCommand(`scoreboard players test ${score} * *`).statusMessage;
    let i = 0;

    if (value == undefined)
    { return 0; }
    while(!(value.substr(0,1).match(/[0-9]/) || value.substr(0,1) == "-"))
    { value = value.substr(1); }
    while(value.substr(i, 1 + i).match(/[0-9]/) || value.substr(i, 1 + i) == "-")
    { i++;}
    return (value.substr(0, i));
}

export function scoreExist(scoreboardName)
{
    const listSc = runCommand("scoreboard objectives list").statusMessage.split("\n");
    for (const ascore of listSc)
    {
        if (ascore.substr(2).startsWith(scoreboardName))
        { return true; }
    }
    return false;
}

export function runCommand(command) {
    try {
        return { error: false, ...Commands.run(command, World.getDimension(`overworld`)) };
    } catch(error) {
        return { error: true };
    }
}

export function tellraw(selector, text)
{
    if(selector.substr(0,1) != "@" ){
        runCommand(`tellraw "${selector}" {"rawtext":[{"text":"${text.replace("\"", "\'")}"}]}`); }
    else {
        runCommand(`tellraw ${selector} {"rawtext":[{"text":"${text.replace("\"", "\'")}"}]}`); }
}
export function log(text)
{ runCommand(`tellraw @a[tag=log] {"rawtext":[{"text":"§7{log} §r${text.replace("\"", "\\\"")}"}]}`)}
export function actionbarRaw(selector, text)
{
    if (selector.substr(0,1) != "@") {
        runCommand(`titleraw "${selector}" actionbar {"rawtext":[{"text":"${text.replace("\"", "\'")}"}]}`); }
    else {
        runCommand(`titleraw ${selector} actionbar {"rawtext":[{"text":"${text.replace("\"", "\'")}"}]}`); }
}

export function findPlayer(name) {
    let pl = World.getPlayers();

    for (let i = 0; i < pl.length; i++) {
        if(name == pl[i].name)
        { return (pl[i]); }
    }
    return (undefined);
}

export function entityExist(name, type) {
    if (runCommand(`testfor @e[name=\"${name}\",type=${type}]`).statusMessage == undefined)
    { return false; }
    else
    { return true; }
}

export function getCurrentDimension(name) //ultimate trick
{
    const player = findPlayer(name);
    const x = player.location.x;
    const y = player.location.y;
    const z = player.location.z;
    try
    {
        runCommand("say " + Commands.run(`testfor @e[name="${name}",x=${x},y=${y},z=${z},r=10]`,World.getDimension("overworld"))).statusMessage;
        return 0;
    }
    catch(er1)
    {
        try
        {
            runCommand("say " + Commands.run(`testfor @e[name="${name}",x=${x},y=${y},z=${z},r=10]`,World.getDimension("nether"))).statusMessage;
            return 1;
        }
        catch(er2)
        {
            try
            {
                runCommand("say " + Commands.run(`testfor @e[name="${name}",x=${x},y=${y},z=${z},r=10]`,World.getDimension("the end"))).statusMessage;
                return 2;
            }
            catch(er3)
            { runCommand("say §eyour in an unknow dimension ?!? : §r" + er3); }
        }
    }
    return -1;
}

export function hasTag(name, tag) {
    if (runCommand(`testfor @e[name="${name}",tag=${tag}]`).statusMessage == undefined) 
    { return false; }
    else
    { return true; }
}

export function findTagsStartWith(name, tag)
{
    const listTag = runCommand(`tag @a[name="${name}"] list`).statusMessage.split(' ');
    const tags = [];
    for (const aTag of listTag) {
        if (aTag.replace('§a','').startsWith(tag)) tags.push(aTag.replace('§a', '').replace('§r', '').replace(',', ' ').trim())
    }
    return (tags);
}
export function findTagsStartWith2(name, tagSelector, tag)
{
    const listTag = runCommand(`tag @e[name="${name}",tag="${tagSelector}"] list`).statusMessage.split(' ');
    const tags = [];
    for (const aTag of listTag) {
        if (aTag.replace('§a','').startsWith(tag)) tags.push(aTag.replace('§a', '').replace('§r', '').replace(',', ' ').trim())
    }
    return (tags);
}

export function findScoresStartWith(name, scoreName)
{
    const listScore = runCommand(`scoreboard objectives list`).statusMessage.split('\n');
    const tags = [];
    for (const aTag of listTag) {
        if (aTag.startsWith("- "+tag+" :")) tags.push(aTag.replace('§a', '').replace('§r', '').replace(',', ' '))
    }
    return (tags);
}

/// Help /-/ Credits ///

export function help(data) {
    tellraw(data.sender.name, "§bBetter faction §av" + version + " §8(by mister art43)§r:");
    tellraw(data.sender.name,"§aAdmin command (need the tag §rAdmin§a to use them) :\n§e+log §7| get some information when players use custom command (adding home, tp...)\n§e+setspawn §7| set the coordinates to the +spawn command\n§e+init all §7|§b/!\\\\use this command to initialize or reinitialize all scoreboard§r\n§e+init §7| use this command to initialize the new limitHome or spawn npc if you used the v0.6.0 or less\n§e+access §8<allow|or|deny> <command:Name> <tag> §7| this command allows the admin to manage all access by command \n(allow: the player will need this tag to use the command \ndeny: if the player has the tag he will not be able to use the command\n(to undo do /tag @e[name=better_faction,tag=better_faction] remove access:<allow|or|deny>:<command:Name>:<tag:Name>\n§e+access §8<allow|or|deny> §elist §7| list all tag and command added.")
    tellraw(data.sender.name, "§aCommon command :\n§e+spawn §7| teleport to spawn\n§e+co §7| display coordinate and chunk location in actionbar\n§e+sethome §8<home:Name> §7| set a new home where you are(only overworld)\n§e+home §8<home:Name> §7| teleport to the home\n§e+delhome §8<home:Name> §7| delet a home\n§e+listhome §7| display all home name\n§e+tpa §8<player:Name> §7| send a request to teleport to another player (work with @shortcut)\n§e+tpaccept §7| accept the tpa. (if you want to deny just wait 30 sec).\n§e+faction create §8<faction:Name> §7| create your own faction\n§e+faction invite §8<player:Name> §7| invite a player in your faction\n§e+faction accept §7| accept invite.\n§e+faction rank §8<player:Name> §7| rank a player (visitor -> member -> deputy head -> leader) (need to be deputy head or leader).\n§e+faction unrank §8<player:Name> §7| unrank a player in your faction (need to be deputy head or leader)\n§e+faction quit §7| leave the faction (will be deleted if nobody is still inside).")
}

///by Mister Art43///